#include <hmg.ch>   


/*

   Program : Versions 
   
   Purpose : Test some version functions and display the results
   
   Uses : ( Included ) HMG_Version(), IDE_Version(), ThisPrgVers() 

   Require : Specify root folder of HMG into "cHMG_RootDir" variable ( Line : 27 )
   
   Author : Bicahi Esgici
   
   Usage : Public domain
   
   History : 2012.10.01 : First release
             2012.10.06 : Added :
                            - OS
                            - Compiler
   
*/
   
PROC Main() 

   cHMG_RootDir := "C:\HMG"           // Specify root folder of HMG
   
   DEFINE WINDOW frmVersions AT 0, 0 WIDTH 400 HEIGHT 300 MAIN 
   
      ON KEY ESCAPE ACTION ThisWindow.Release       
      
		DEFINE MAIN MENU

			POPUP '?'
				ITEM 'Versiyons' 		ACTION DispVers() 
         END POPUP // ?
       
 		END MENU // MAIN
      
   END WINDOW // frmVersions
   
   frmVersions.Center
   frmVersions.Activate
   
RETURN // Main()

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   
FUNCTION HMG_Version()                        // Version of HMG
RETURN MEMOREAD( cHMG_RootDir + "\version.txt" ) 
   
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

FUNCTION IDE_Version()                        // Version of HMG-IDE
RETURN TRANSFORM( DTOS( FILEDATE( cHMG_RootDir + "\IDE\IDE.EXE" ) ),"@R 9999.99.99")

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

FUNCTION ThisPrgVers()                          // Version of This ( current ) program 

   LOCAL cExeName := EXENAME(),;
          cRVal  
          
   LOCAL cExeDate := SUBSTR( TRANSFORM( DTOS( FILEDATE( cExeName ) ),"@R 9999.99.99"), 4 )
   
   cRVal := SUBSTR( cExeName, RAT( "\", cExeName ) + 1 )
   cRVal := LEFT( cRVal, RAT( ".", cRVal ) - 1 )
   cRVal += " -- " + cExeDate 
   
RETURN cRVal // ThisPrgVers()
   
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

PROCEDURE DispVers()                           // Display Version Info
 
   LOCAL aVers := { { "OS :",            OS()          },;
                     { "Compiler : ",     HB_Compiler() },;
                     { "Harbour : ",      Version()     },;
                     { "HMG : ",          HMG_Version() },;
                     { "IDE : ",          IDE_Version() },;
                     { "This program : ", ThisPrgVers() } }
                     
	DEFINE WINDOW frmDispVers ;
		AT 0,0 ;
		WIDTH 350 ;
		HEIGHT 180 ;
		TITLE 'Versions' ;
		MODAL

      ON KEY ESCAPE ACTION ThisWindow.Release       
      
		@ 20, 20 GRID grdDispVers ;
			WIDTH 310 ;
			HEIGHT 120 ;
			HEADERS {'',''} ;
			WIDTHS {100,200};
			ITEMS aVers ;
			VALUE 1 ;
			TOOLTIP 'Versions of programs' ;
         NOLINES ;
         NOHEADERS ;
         JUSTIFY { GRID_JTFY_RIGHT, GRID_JTFY_LEFT } ;

	END WINDOW // frmDispVers

	frmDispVers.Center

	frmDispVers.Activate

RETURN // DispVers()   

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

   